
/*
 * @(#)LongStats.java	1.3 99/01/13
 *
 * Copyright (c) 1996-1999 James Begole.  All Rights Reserved.
 *
 * James Begole MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY 
 * OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. James Begole SHALL NOT BE LIABLE
 * FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * THIS SOFTWARE IS NOT DESIGNED OR INTENDED FOR USE OR RESALE AS ON-LINE
 * CONTROL EQUIPMENT IN HAZARDOUS ENVIRONMENTS REQUIRING FAIL-SAFE
 * PERFORMANCE, SUCH AS IN THE OPERATION OF NUCLEAR FACILITIES, AIRCRAFT
 * NAVIGATION OR COMMUNICATION SYSTEMS, AIR TRAFFIC CONTROL, DIRECT LIFE
 * SUPPORT MACHINES, OR WEAPONS SYSTEMS, IN WHICH THE FAILURE OF THE
 * SOFTWARE COULD LEAD DIRECTLY TO DEATH, PERSONAL INJURY, OR SEVERE
 * PHYSICAL OR ENVIRONMENTAL DAMAGE ("HIGH RISK ACTIVITIES"). James Begole
 * SPECIFICALLY DISCLAIMS ANY EXPRESS OR IMPLIED WARRANTY OF FITNESS FOR
 * HIGH RISK ACTIVITIES.
 *
 * @author   James "Bo" Begole
 * @author   Rich Burridge
 * @version  1.5 - 11th January 1999. 
 */

package examples.ppong;

import java.awt.*;
import java.io.*;

public class 
LongStats implements PpongDebugFlags {

    private long    mean        = 0;
    private long    data[]      = null;
    private int     maxNumData;
    private int     nextIndex   = 0;
    private int     numElements = 0;
    private boolean updated     = false;
    private boolean fullSet     = false;


    public 
    LongStats(int maxNumData) {
        data = new long[maxNumData];    
        this.maxNumData = maxNumData;
    }


    public synchronized void 
    add(long newItem) {
        data[nextIndex] = newItem;
        nextIndex++;
        nextIndex %= maxNumData;
        updated = true;
        if (numElements < maxNumData) {

// Once numElements == maxNumData, leave it at that value.

            numElements++;
	}
    }


    public synchronized long 
    getMean() {
        if (updated) {
            calculateMean();
	}
        return(mean);
    }


    private void 
    calculateMean() {
        long total = 0;

        for (int i = 0; i < numElements; i++) {
            total += data[i];
        }

        mean = total / numElements;

        if (LongStats_Debug) {
	    System.err.println("LongStats: calculateMean: " +
			       " numElements=" + numElements +
			       " mean = " + mean);
	}
    }
}
