
/*
 * @(#)ToggleButton.java	1.3 99/01/13
 *
 * Description: ToggleButton extends the Button class. It provides a method 
 *              by which one may toggle the label between two strings.
 *              Might be enhanced to resize button based on size of current 
 *              label string.
 *
 * Copyright (c) 1996-1999 James Begole.  All Rights Reserved.
 *
 * James Begole MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY 
 * OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. James Begole SHALL NOT BE LIABLE
 * FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * THIS SOFTWARE IS NOT DESIGNED OR INTENDED FOR USE OR RESALE AS ON-LINE
 * CONTROL EQUIPMENT IN HAZARDOUS ENVIRONMENTS REQUIRING FAIL-SAFE
 * PERFORMANCE, SUCH AS IN THE OPERATION OF NUCLEAR FACILITIES, AIRCRAFT
 * NAVIGATION OR COMMUNICATION SYSTEMS, AIR TRAFFIC CONTROL, DIRECT LIFE
 * SUPPORT MACHINES, OR WEAPONS SYSTEMS, IN WHICH THE FAILURE OF THE
 * SOFTWARE COULD LEAD DIRECTLY TO DEATH, PERSONAL INJURY, OR SEVERE
 * PHYSICAL OR ENVIRONMENTAL DAMAGE ("HIGH RISK ACTIVITIES"). James Begole
 * SPECIFICALLY DISCLAIMS ANY EXPRESS OR IMPLIED WARRANTY OF FITNESS FOR
 * HIGH RISK ACTIVITIES.
 *
 * @author   James "Bo" Begole
 * @author   Rich Burridge
 * @version  1.5 - 11th January 1999. 
 */

package examples.ppong;

import java.awt.Button;

public class 
ToggleButton extends Button implements PpongDebugFlags {

    private String label1, label2;


    public 
    ToggleButton(String label1, String label2) {
        super((label1.length() >= label2.length()) ? label1: label2);
        this.validate();
        this.label1 = new String(label1);
        this.label2 = new String(label2);
        setLabel(this.label1);
    }


    public void 
    toggle() {
        String buttonLabel = getLabel();

        if (buttonLabel.equals(label1)) {
            setLabel(label2);
        } else {
            setLabel(label1);
        }
        if (ToggleButton_Debug) {
            System.err.println("Toggling to: " + getLabel());
	}
    }
}

