
/*
 * @(#)AudioClick.java	1.12 99/01/07
 *
 * Copyright (c) 1993-1999 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You shall
 * not disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

package examples.sound;

/**
 * A clip of audio data
 *
 * To allow memory optimizations, an audio click object can be used
 * as a temporary buffer using its offset and length variables.
 *
 * @version     1.5 - 7th January 1999
 * @author	Behfar Razavi
 */

public class
AudioClick implements SoundDebugFlags {

    /** The data. */

    byte buffer[];
    int offset;
    int length;


/** Initialize buffer, length and offset variables. */

    public
    AudioClick(byte buffer[], int offset, int length) {
        if (AudioClick_Debug) {
            System.err.println("AudioClick: constructor: " +
                               " offset: " + offset +
                               " length: " + length);
        }

        this.buffer = buffer;
        this.length = length;
        this.offset = offset;
    }


/** Update the length and offset variables to reflect the amount of audio
 *  left in the buffer.
 */

    public void
    consume(int n) {
        if (AudioClick_Debug) {
            System.err.println("AudioClick: consume: " + n);
        }

        if (n > length) {
            length = 0;
        } else {
            length -= n;
            offset += n;
        }
    }
}
