
/*
 * @(#)ChatConsumer.java	1.12 99/01/07
 *
 * Copyright (c) 1993-1999 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You shall
 * not disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

package examples.chat;

import com.sun.media.jsdt.*;
import java.awt.*;
import java.applet.Applet;

/**
 * This is just a simple server/client based proof-of-concept
 * implementation to make sure that the Shared Data classes have
 * all the required API in them.
 *
 * It's based on the chat demonstration which is part of the
 * west-coast rmi distribution.
 *
 * @version     1.5 - 7th January 1999
 * @author      Rich Burridge
 */

class
ChatConsumer implements ChannelConsumer, ChatDebugFlags {

    /** The name of this channel consumer. */
    protected String name;

    /** The location to write all messages received. */
    TextArea messageArea;


    public
    ChatConsumer(String name, TextArea messageArea) {
        if (ChatConsumer_Debug) {
            System.err.println("ChatConsumer: constructor.");
        }

        this.name = name;
        this.messageArea = messageArea;
    }
 
 
    public synchronized void
    dataReceived(Data data) {
        String  message;
        int     position   = 0;
        int     priority   = data.getPriority();
        String  senderName = data.getSenderName();
        Channel channel    = data.getChannel();
        String  theData    = data.getDataAsString();
         
        if (ChatConsumer_Debug) {
            System.err.println("ChatConsumer: dataReceived " +
                               " Priority "    + priority +
                               " Channel "     + channel +
                               " Sender name " + senderName +
                               " Data "        + theData);
        }
         
/* Construct message and output it to the end of the message area. */
         
        message = senderName + ": " + theData + "\n";
        position = messageArea.getText().length();
        messageArea.insert(message, position);
    }
}
